// File name: projects/04/Sort/Sort.asm
//  Initial Outer Loop
	@outerIndex
	M=0;
(STARTOUTERLOOP)
//  Go through all array elements 
	@R15
	D=M;
	@outerIndex
	D=D-M;
	@ENDOUTERLOOP
	D;JEQ
	@innerIndex
	M=0;
(STARTINNERLOOP)
//  Elements before innerIndex are already in place
	@R15
	D=M-1;
	@outerIndex
	D=D-M;
	@innerIndex
	D=D-M;
	@ENDINNERLOOP
	D;JEQ
	@R14
	D=M
	@innerIndex
	D=D+M;
	@temp1Idx
	AM=D;
	D=M;
	@temp1Value
	M=D;
	@R14
	D=M+1
	@innerIndex
	D=D+M;
	@temp2Idx
	AM=D;
	D=M;
	@temp2Value
	M=D;
	@temp1Value
	D=M-D;
	@ENDSWAP
	D;JGE
//  Swap
	@temp1Value
	D=M
	@temp2Idx
	A=M
	M=D
	@temp2Value
	D=M
	@temp1Idx
	A=M
	M=D
(ENDSWAP)	
	@innerIndex
	M=M+1;
	@STARTINNERLOOP
	0;JMP
(ENDINNERLOOP)
	@outerIndex
	M=M+1;
	@STARTOUTERLOOP
	0;JMP
(ENDOUTERLOOP)